<template>
  <div>
    <div class="data-markup__block">
      <div class="line">
        <div class="item">
          <ob-select
              :items="markupClients"
              display-exp="name"
              value-exp="uuid"
              label="Для клиента"
              placeholder="Выберите клиента"
              :is-standart="true"
              @input="getClientInfo"
          />
        </div>
        <div v-if="clientUuid !== '' && clientAreas.length" class="item" >
          <button
              @click="deleteArea"
              class="delete">
            <i class="icon trash-sm"/>
            Вернуться к общим настройкам
          </button>
        </div>
      </div>

      <div class="data-markup__table">
        <ob-table
            ref="ob-table"
            :items="clientAreas"
            :columns="columns"
            :functionalPanel="true ? clientName !== '' : false"
            :showAddButton="true ? clientName !== '' : false"
            @add="$refs['add-modal'].open()"
            group-by="locationStartName"
            :group-title-html="groupTitle"
            :addButtonText="'Добавить направление'"
        >
          <template v-slot:cities="{ data }">
            <i class="icon blue city"/>
            <span class="text"> {{data.item.locationEndName}}</span>
          </template>
          <template v-slot:markup="{ data }">
            <ObInput
                v-model="data.item.markup"
                type="money:0"
                :isConvertMoney="false"
                @blur="saveMarkup(data.item)"
            />
          </template>
          <template v-slot:deleteRow="{ data }">
            <ObMenuDropdown :items="getDropdownItems(data)"/>
          </template>
        </ob-table>
      </div>
    </div>
    <ObModal
        ref="add-modal"
        size="large"
        title="Направление"
        title-second="Добавление"
    >
      <AddModal
          :clientName="clientName"
          :clientUuid="clientUuid"
          @closeAddModal="refresh"/>
    </ObModal>
  </div>
</template>

<script>
  import ObTable from "common-components/src/obComponents/obTable";
  import ObInput from "common-components/src/obComponents/obInput";
  import ObSelect from "common-components/src/obComponents/obSelect";
  import ObModal from "common-components/src/obComponents/obModal";
  import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown';
  import AddModal from './AddModal';
  import {mapActions, mapGetters} from "vuex";
  import api from "@/api";
  export default {
    name: "DirectionSettings",
    components: {
      ObTable,
      ObInput,
      ObSelect,
      ObModal,
      AddModal,
      ObMenuDropdown
    },
    data() {
      return {
        items: [],
        client: {},
        clientName: '',
        clientUuid: '',
        clientMarkup: null,
        clientAreas: []
      }
    },
    computed: {
      ...mapGetters({
        userUuid: 'user/participantUuid',
        markupClients: 'clicarSettings_2/markupClients',
      }),
      columns() {
        return [
          {
            title: 'Куда',
            key: 'cities',
            slotName: 'cities'
          },
          {
            title: 'Наценка, %',
            key: 'markup',
            slotName: 'markup'
          },
          {
            title: '',
            key: 'delete_row',
            slotName: 'deleteRow',
            sortDisable: true
          }
        ]
      }
    },
    methods: {
      ...mapActions({
        getClientMarkup: 'clicarSettings_2/getClientMarkup',
      }),
      async getClients(){
        await api.clicar_setting_2.getClientMarkup(this.userUuid, this.clientUuid).then(res => {
          this.clientAreas = res.data
        })
      },
      async getClientInfo(item) {
        this.client = this.markupClients.filter(client =>{
          return client.uuid === item
        })
        this.clientName = this.client[0].name
        this.clientUuid = this.client[0].uuid
        this.clientMarkup = this.client[0].markup

        this.getClients()

      },
      async refresh(){
        this.$refs['add-modal'].close()
        this.getClients()
      },
      groupTitle(value) {
        return value
      },
      async saveMarkup(item){
        let formData ={
          "locationStartUuid": item.locationStartUuid,
          "locationEndUuid":  item.locationEndUuid,
          "markup": item.markup
        }
        await api.clicar_setting_2.saveClientMarkup(this.userUuid, this.clientUuid, formData).then(() => {

        })
      },
      async onDelete(item) {
        let formData = {
          "clientUuid": this.clientUuid,
          "startLocationUuid": item.locationStartUuid,
          "endLocationUuid": item.locationEndUuid
        }
        await api.clicar_setting_2.deleteClientMarkup(this.userUuid, formData).then(() => {
          this.getClients()
        })
      },
      getDropdownItems(data) {
        return [
          {
            title: 'Удалить направление',
            className: 'menu-button-danger',
            method: () => this.onDelete(data.item)
          }
        ]
      },
      async deleteArea(){
        await api.clicar_setting_2.deleteMarkup(this.userUuid, this.clientUuid).then(() => {
          this.getClients()
        })
      }
    }
  }
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";
.data-markup {
  &__block{
    margin-top: 32px;
    .line{
      display: flex;
      justify-content: space-between;
      align-items: center;
      .item{
        &:first-child{
          width: 600px;
        }
        button{
          @include font-mixin(14px, 16px, 400,  $color-error, .2px);
          border: none;
          outline: none;
          cursor: pointer;
        }
      }
    }
  }
  &__title{
    margin-bottom: 15px;
    @include font-mixin(16px, 20px, 700, $topMenuTextHover, .4px);
  }
  &__text{
    @include font-mixin(24px, 29px, 400, $color-grey-span, .4px);
    text-align: center;
    margin: 70px 0 35px;
  }
  &__button{
    background: none;
    @include font-mixin(16px, 20px, 400, $color-blue-navy-blue, .4px);
    margin: 0 auto;
    display: block;
    border: none;
    cursor: pointer;
    outline: none;
  }
}
::v-deep table.table-data{
  min-width: 100%;
  td{
    &:nth-child(2){
      width: 120px;
    }
  }
}
::v-deep .ob-input-wrap{
  .input{
    text-align: right;
  }
}
::v-deep td:first-child > .td-container, th:first-child > .td-container {
  padding-left: 100px;
}
::v-deep .data-markup__block .ob-input-wrap{
  height: 30px;
  .input{
    text-align: right;
  }
}
</style>
<style lang="scss">
.data-markup__table {
  .cities {
    padding-left: 30px;
  }

  .blue {
    color: $color-blue-navy-blue;
    font-size: 16px;
  }

  .text {
    font-size: 14px;
    line-height: 18px;
    letter-spacing: 0.2px;
    color: $color-text-base;
  }

  .obInputRow {
    border: 1px solid $color-grey-border !important;
    box-shadow: inset 0px 3px 6px rgba(25, 30, 50, 0.1) !important;
    border-radius: 3px !important;
  }

  .menu-button-danger {
    color: $color-error;
  }

  .ob-input-wrap.--theme-default {
    border: 1px solid $color-grey-border !important;
    box-shadow: inset 0px 3px 6px rgba(25, 30, 50, 0.1) !important;
    border-radius: 3px !important;
    height: 27px;

    input {
      font-size: 12px;
    }
  }
}
</style>